#! /bin/bash
# Copyright (c) 1995-2002 SuSE Linux AG, Nuernberg, Germany.
# All rights reserved.
#
# Author: Kurt Garloff <http://www.suse.de/feedback>
#         Thomas Renninger <http://www.suse.de/feedback>
#
# /etc/init.d/cpuspeed
#   and its symbolic link
# /(usr/)sbin/rccpuspeed
#
# Template system startup script for some example service/daemon cpuspeed
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
# 
# Note: This template uses functions rc_XXX defined in /etc/rc.status on
# UnitedLinux (UL) based Linux distributions. If you want to base your 
# script on this template and ensure that it works on non UL based LSB 
# compliant Linux distributions, you either have to provide the rc.status
# functions from UL or change the script to work without them.
#
### BEGIN INIT INFO
# Provides:          cpuspeed
# Required-Start:    $syslog $remote_fs
# X-UnitedLinux-Should-Start: acpid
# Required-Stop:     $syslog $remote_fs
# X-UnitedLinux-Should-Stop: acpid
# X-UnitedLinux-Default-Enabled: yes
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: cpuspeed daemon providing CPU clock control
# Description:       Start cpuspeed to adjust CPU clock depending on CPU usage
#	state of power supply and CPU temperature. Configuration in
#	/etc/sysconfig/powermanagement.
### END INIT INFO
# 
# Any extensions to the keywords given above should be preceeded by 
# X-VendorTag- (X-UnitedLinux- for us) according to LSB.
# 
# Notes on Required-Start/X-UnitedLinux-Should-Start:
# * There are two different issues that are solved by Required-Start
#    and X-UnitedLinux-Should-Start
# (a) Hard dependencies: This is used by the runlevel editor to determine
#     which services absolutely need to be started to make the start of
#     this service make sense. Example: nfsserver should have
#     Required-Start: portmap
#     Also, required services are started before the dependent ones.
#     The runlevel editor will warn about such missing hard dependencies
#     and suggest enabling. During system startup, you may expect an error,
#     if the dependency is not fulfilled.
# (b) Specifying the init script ordering, not real (hard) dependencies.
#     This is needed by insserv to determine which service should be
#     started first (and at a later stage what services can be started
#     in parallel). The tag X-UnitedLinux-Should-Start: is used for this.
#     It tells, that if a service is available, it should be started
#     before. If not, never mind.
# * When specifying hard dependencies or ordering requirements, you can 
#   use names of services (contents of their Provides: section)
#   or pseudo names starting with a $. The following ones are available
#   according to LSB (1.1):
#	$local_fs		all local file systems are mounted
#				(most services should need this!)
#	$remote_fs		all remote file systems are mounted
#				(note that /usr may be remote, so
#				 many services should Require this!)
#	$syslog			system logging facility up
#	$network		low level networking (eth card, ...)
#	$named			hostname resolution available
#	$netdaemons		all network daemons are running
#   The $netdaemons pseudo service has been removed in LSB 1.2.
#   For now, we still offer it for backward compatibility.
#   These are new (LSB 1.2):
#	$time			the system time has been set correctly	
#	$portmap		SunRPC portmapping service available
#   UnitedLinux extensions:
#	$ALL			indicates that a script should be inserted
#				at the end
# * The services specified in the stop tags 
#   (Required-Stop/X-UnitedLinux-Should-Stop)
#   specify which services need to be still running when this service
#   is shut down. Often the entries there are just copies or a subset 
#   from the respective start tag.
#
# Note on runlevels: 
# 0 - halt/poweroff 			6 - reboot
# 1 - single user			2 - multiuser without network exported
# 3 - multiuser w/ network (text mode)  5 - multiuser w/ network and X11 (xdm)
# 
# Note on script names:
# http://www.linuxbase.org/spec/refspecs/LSB_1.2.0/gLSB/scrptnames.html
# A registry has been set up to manage the init script namespace.
# http://www.lanana.org/
# Please use the names already registered or register one or use a
# vendor prefix.

# Check for missing binaries (stale symlinks should not happen)
CPUSPEED_BIN=/usr/sbin/cpuspeed
test -x $CPUSPEED_BIN || exit 5

# Check for existence of needed config file and read it
CPUSPEED_CONFIG=/etc/sysconfig/powermanagement
test -r $CPUSPEED_CONFIG || exit 6
. $CPUSPEED_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
#      rc_splash arg    sets the boot splash screen to arg (if active)
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

LOGGER="/bin/logger"

case "$1" in
    start)
	echo -n "Starting cpuspeed "
	
	# load needed modules ##
	# module specfied in /etc/sysconfig/powermanagement
	if [ "$CPUFREQD_MODULE" ];then
	    modprobe -q "$CPUFREQD_MODULE" "$CPUFREQD_OPTS" &>/dev/null
	    RETVAL=$?
	# try to load one of the modules we know
	else 
	    for MODULE in speedstep-centrino speedstep-ich acpi p4-clockmod powernow-k8 powernow-k7 powernow-k6; do
		modprobe $MODULE &>/dev/null
		RETVAL=$?
		test "$RETVAL" = 0 && break
	    done
	    # skip if no module could be loaded!
	    if [ "$RETVAL" != 0 ]; then
		$LOGGER -t cpuspeed "CPU frequency scaling is not supported with the current settings! Is this machine supporting speedstep or powernow technology? Please have a look in /etc/sysconfig/powermanagement"
		rc_status -s
		rc_exit
		exit 
            fi
	fi
	if [ "$RETVAL" = 0 ] ; then
	    modprobe -q cpufreq_userspace &>/dev/null && RETVAL=$?
	fi
	if [ "$RETVAL" = 0 ] ; then
	    if [ "$CPUFREQD_SAVE_BATTERY_POWER" = "yes" ] ; then
		AC_ADAPTER=`ls /proc/apm \
			/proc/acpi/ac_adapter/*/state 2>/dev/null`
		AC_ADAPTER=${AC_ADAPTER:+ -a $AC_ADAPTER}
	    fi
	    if [ -n "$CPUFREQD_THERMAL_LIMIT" ] ; then
	        THERMAL=`ls /proc/acpi/thermal_zone/*/temperature 2>/dev/null |
	                    head -n 1`
	        THERMAL=${THERMAL:+ -t $THERMAL $CPUFREQD_THERMAL_LIMIT}
	    fi
	    if [    -n "$CPUFREQD_IDLE_RATIO_FAST_UP" \
                 -o -n "$CPUFREQD_IDLE_RATIO_UP" \
	         -o -n "$CPUFREQD_IDLE_RATIO_DOWN" ] ; then
		: ${CPUFREQD_IDLE_RATIO_FAST_UP:=10} 
		: ${CPUFREQD_IDLE_RATIO_UP:=25} 
		: ${CPUFREQD_IDLE_RATIO_DOWN:=75}
		for RATIO in CPUFREQD_IDLE_RATIO_FAST_UP \
		             CPUFREQD_IDLE_RATIO_UP \
		             CPUFREQD_IDLE_RATIO_DOWN; do
		    if [ "${!RATIO}" -ge 100 ] ; then
			eval $RATIO=1.0
		    elif [ "${!RATIO}" -le 0 ] ; then
			eval $RATIO=0.0
		    else
			eval $RATIO="0.${!RATIO}"
		    fi
		done
		IDLE_RATIO="-p ${CPUFREQD_IDLE_RATIO_FAST_UP} \
		               ${CPUFREQD_IDLE_RATIO_UP} \
		               ${CPUFREQD_IDLE_RATIO_DOWN}"
	    fi
	    ## Start daemon with startproc(8). If this fails
	    ## the return value is set appropriately by startproc.
	    startproc $CPUSPEED_BIN -d ${AC_ADAPTER} ${THERMAL} ${IDLE_RATIO} \
	    	                 ${CPUFREQD_INTERVAL:+ -i $CPUFREQD_INTERVAL} 
	else
	    $LOGGER -t cpuspeed "CPU frequency scaling is not supported with the current settings! Please have a look in /etc/sysconfig/powermanagement"
	    rc_failed 1
	fi
	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down cpuspeed "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.

	killproc -TERM $CPUSPEED_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart)
	## Do a restart only if the service was active before.
	## Note: try-restart is not (yet) part of LSB (as of 1.2)
	$0 status >/dev/null &&  $0 restart

	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload|reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service cpuspeed "
	killproc -HUP $CPUSPEED_BIN
	rc_status -v
	;;
    high)
	echo -n "service cpuspeed set CPU to highest clock speed "
	killproc -USR1 $CPUSPEED_BIN
	rc_status -v
	;;
    low)
	echo -n "service cpuspeed set CPU to lowest clock speed "
	killproc -USR2 $CPUSPEED_BIN
	rc_status -v
	;;
    status)
	echo -n "Checking for service cpuspeed "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	checkproc $CPUSPEED_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|high|low}"
	exit 1
	;;
esac
rc_exit
